// Like A LCD Ver 0.11
// Programmed by Teikoku 2015-2016

// LLGバージョン番号
var g_LLGVER = '0.11';
// 行データ・要素データ保存用
var g_LineData = new Array();
var g_ArgData = new Array();
// ラベルデータ・ラベル行番号保存用
var g_LabelName = new Array();
var g_LabelLine = new Array();
// 実行行番号・最大行番号
var g_LineNumber;
var g_EndLineNumber;
// エラーフラグ・エラーメッセージ・エラーID
var g_ErrorFlag;
var g_ErrorMsg = new Array( 'Internal Error','Syntax Error','Devided by Zero','Undefined Label',
							'Return without Gosub','Loop without Repeat');
var NO_ERROR = 0;
var SYNTAX_ERROR = 1;
var DEVIDED_BY_ZERO = 2;
var UNDEFINED_LABEL = 3;
var RETURN_WITHOUT_GOSUB = 4;
var LOOP_WITHOUT_REPEAT = 5;
// プログラム制御用
var g_Status;
var g_ProgCount;
var PROG_READY = 0;
var PROG_BUSY = 1;
var PROG_WAITING = 2;
var PROG_END = 3;
// 実行モード(0：開発 1：実行)
var PROG_AUTOEXEC = 1;
// 変数保存用
var VARIABLE_NUMBER = 26*37;
var g_Variable = new Array(VARIABLE_NUMBER);
var g_VariableName = new Array(VARIABLE_NUMBER)
var g_VarName1 = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
var g_VarName2 = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ';
// 特別変数
var g_RepeatLine;	// リピート時戻る行
var g_Count;		// リピートカウント
var g_MaxCount;		// リピート最大値
var g_GosubLine;	// GOSUB実行位置（RETURNで使用）
// 時間待ち用
var g_StartTime;
var g_WaitTime;

// 最初に実行する関数
function initProg() {
	clearTimeout(g_TimerID);
	// 変数命名
	progVarNameSetting();
	// 初期画面
	LCDCls(0);
	LCDPrint('Like A LCD Version '+g_LLGVER);
	LCDPrint('Programmed by Teikoku');
	LCDPrint('ok');
	g_progInit = 0;
	if (PROG_AUTOEXEC == 1) {
		g_TimerID = setTimeout("progExec()",1000);
	}
}

// 実行ボタンが押下されたとき
function progExec() {
	var i;
	// 起動中なら戻るだけ
	if (g_progInit == 1) return;
	// テキストボックスのデータを行単位で配列に保存する
	var textData = document.getElementById("src").value;
	g_LineData = new Array();
	g_LineData = textData.split("\n");
	g_EndLineNumber = g_LineData.length;
	// ラベルがあったら名前と位置を保存
	g_LabelName = new Array();
	g_LabelLine = new Array();
	for (i=0;i<g_EndLineNumber;i++) {
		if (g_LineData[i].charAt(0)=='*') {
			g_LabelName.push(g_LineData[i]);
			g_LabelLine.push(i);
		}
	}
	// 変数データ初期化
	progVarInit();
	setInitChrData();
	// 実行行番号を0にセット
	g_LineNumber = 0;
	g_ErrorFlag = NO_ERROR;
	g_Count = -1;
	g_RepeatLine = -1;
	g_GosubLine = -1;
	g_Status = PROG_READY;
	g_clickable = false;
	//
	if (g_TimerID != undefined) { clearInterval(g_TimerID); }
	g_TimerID = setInterval("progProcess()",5);
}

// プログラム制御
function progProcess() {
	var i;
	if (g_Status == PROG_WAITING) {
		progWaiting();
	} else {
		for (i=0;i<30;i++) {
			readLineData();
			if (g_Status != PROG_READY) break;
		}
	}
	if (g_Status == PROG_END) {
		clearInterval(g_TimerID);
		progEnd();
	}
}

// 時間待ち処理
function progWaiting() {
	var dt0 = new Date();
	if ((dt0.getTime() - g_StartTime) >= g_WaitTime) g_Status = PROG_READY;
}

// 1行読み込んで飛ぶ
function readLineData() {
	// 要素ごとに分割
	g_ArgData = new Array();
	g_ArgData = g_LineData[g_LineNumber].split(",");
	// 空行以外かつ先頭文字が"*","/",";"（コメント行）以外の場合はSyntax Errorをセットして終了
	if (g_ArgData[0] != '' && g_ArgData[0].search(/^[\*\/\;]/) == -1) {
		 g_ErrorFlag = SYNTAX_ERROR;
	}
	// 先頭文字が"/"の場合、要素の先頭の要素によって処理を行う
	if (g_ArgData[0].charAt(0) == '/') {
		switch (g_ArgData[0].toLowerCase()) {
		case '/end':
		case '/e':
			LLGEnd(); break;
		case '/cls':
		case '/c':
			LLGCls(); break;
		case '/locate':
		case '/l':
			LLGLocate(); break;
		case '/print':
		case '/p':
			LLGPrint(); break;
		case '/pchr':
			LLGPrintChr(); break;
		case '/let':
		case '/=':
			LLGLet(); break;
		case '/setchr':
			LLGSetChr(); break;
		case '/calc':
			LLGCalc(); break;
		case '/concat':
			LLGConcat(); break;
		case '/goto':
			LLGGoto(); break;
		case '/gosub':
			LLGGosub(); break;
		case '/return':
		case '/ret':
			LLGReturn(); break;
		case '/repeat':
			LLGRepeat(); break;
		case '/loop':
			LLGLoop(); break;
		case '/if':
			LLGIf(); break;
		case '/strif':
		case '/sif':
			LLGStrIf(); break;
		case '/rand':
		case '/rnd':
			LLGRandom(); break;
		case '/len':
			LLGLen(); break;
		case '/substr':
			LLGSubStr(); break;
		case '/replace':
			LLGReplace(); break;
		case '/instr':
			LLGInstr(); break;
		case '/repstr':
			LLGRepeatString(); break;
		case '/wait':
			LLGWait(); break;
		case '/button':
		case '/btn':
			LLGButton(); break;
		case '/btnon':
			LLGButtonResponse(true); break;
		case '/btnoff':
			LLGButtonResponse(false); break;
		case '/btngoto':
			LLGButtonGo(); break;
		case '/getms':
			LLGGetTime(); break;
		case '/beep':
			LLGSound(); break;
		case '/abs':
			LLGAbsolute(); break;
		case '/sqr':
		case '/sqrt':
			LLGSquareRoot(); break;
		case '/swap':
			LLGSwap(); break;
		default:
			// 文法ミス判定でSyntax Error
			g_ErrorFlag = SYNTAX_ERROR;
		}
	}
	// エラーが発生したらメッセージ出して終了
	if (g_ErrorFlag != NO_ERROR) { progPrintError(); g_Status = PROG_END;}
	// 次の行へ
	g_LineNumber++;
	// 最終行に到達したらプログラム終了
	if (g_LineNumber >= g_EndLineNumber) g_Status = PROG_END;
}

// プログラム終了
function progEnd() {
	LCDPrint('ok');
}

// エラーを表示する
function progPrintError() {
	LCDCls(0);
	LCDPrint(g_ErrorMsg[g_ErrorFlag]+'　in '+(g_LineNumber+1));
	LCDPrint((g_LineNumber+1)+':'+g_LineData[g_LineNumber].substr(0,18));
	LCDSoundEffect(0);
}

// 変数命名
function progVarNameSetting() {
	var i,j;
	for(i=0;i<g_VarName1.length;i++) {
		g_VariableName[i*(g_VarName2.length+1)] = '@' + g_VarName1.charAt(i);
		for(j=0;j<g_VarName2.length;j++) {
			g_VariableName[i*(g_VarName2.length+1)+j+1] = '@' + g_VarName1.charAt(i) + g_VarName2.charAt(j);
		}
	}
}

// 変数データ初期化
function progVarInit() {
	var i;
	for(i=0;i<g_Variable.length;i++) {
		g_Variable[i] = 0;
	}
}

// 変数番地を返す
// 戻り値：-1　該当変数なし(SYNTAX_ERROR) / 0～　通常変数
function progVariableIndex(str) {
	var i,r;
	r = -1;
	for (i=0;i<g_Variable.length;i++) {
		if (str == g_VariableName[i] ) {
			r = i;
			break;
		}
	}
	return r;
}

// 変数内容置き換え処理
function progVarReplace(str) {
	var i,c,r;
	c = '';
	// 特別変数の場合はそこから値を引っ張ってくる
	if (str == '@CNT')  { return String(g_Count); };
	if (str == '@BTN')  { return String(g_button); };
	r = progVariableIndex(str);
	if (r != -1) { c = String(g_Variable[r]); }
	return c;
}

// 文字列を計算評価する
function progCalc(str) {
	var args = new Array();
	var i,j,a,b,f,c;
	str = String(str);
	// +-/*\%で分割する
	args = str.split(/([\+\-\*\/\\\%])/);
	// 先頭要素が空白なら除去
	if (args[0]=='') args.shift();
	// 先頭要素が+か-なら0を先頭に追加
	if (args[0]=='+' || args[0]=='-') args.unshift('0');
	// 先頭要素が+か-以外の記号（*/\%）ならSyntax Errorで終了
	if (args[0].search(/^[\*\/\\\%]/)!=-1) { g_ErrorFlag = SYNTAX_ERROR; return;}
	// 変数があれば変数の値に置き換える
	for (i=0;i<args.length;i++) {
		if (args[i].charAt(0) == '@') args[i] = progVarReplace(args[i]);
	}
	// 文字列をくくる記号('")があれば除去する
	for (i=0;i<args.length;i++) {
		if (args[i].search(/^[\'\"]/) != -1 && args[i].search(/[\'\"]$/) != -1) {
			args[i] = args[i].substr(1,args[i].length-2);
		}
	}
	// 優先順位１　*や/や\や%
	for (j=0;j<=1;j++) {
		f = 1;
		for (i=0;i<args.length;i++) {
			if (args[i].length == 1 && args[i].search(/[\*\/\\\%]/) != -1) {
				c = i;
				i = args.length;
				a = Number(args[c-1]);
				b = Number(args[c+1]);
				if (args[c] == '*') a=a*b;
				if (args[c] == '/' || args[c] == '\\' || args[c] == '%') {
					if (b == 0) { g_ErrorFlag = DEVIDED_BY_ZERO; return 0; }
					if (args[c] == '/') a=a/b;
					if (args[c] == '\\') a=parseInt(a/b);
					if (args[c] == '\%') a=a%b;
				}
				f = 0;
				args[c-1]=String(a);
				args.splice(c,2);
			}
		}
		j=f;
	}
	// 優先順位２　+や-
	for (j=0;j<=1;j++) {
		f = 1;
		for (i=0;i<args.length;i++) {
			if (args[i] == '+' || args[i] == '-') {
				c = i;
				i = args.length;
				a = Number(args[c-1]);
				b = Number(args[c+1]);
				if (args[c] == '+') a=a+b;
				if (args[c] == '-') a=a-b;
				f=0;
				args[c-1]=String(a);
				args.splice(c,2);
			}
		}
		j=f;
	}
	return args[0];
}

// 文字列評価用
function progConcat(str) {
	var args = new Array();
	var i,j,f,c;
	str = String(str);
	// &で分割する
	args = str.split(/([\&])/);
	// 先頭要素が空白なら除去
	if (args[0]=='') args.shift();
	// 先頭要素が"&"ならSyntax Errorで終了
	if (args[0]=='&') { g_ErrorFlag = SYNTAX_ERROR; return 0;}
	// 変数があれば変数の値に置き換える
	for (i=0;i<args.length;i++) {
		if (args[i].charAt(0) == '@') args[i] = progVarReplace(args[i]);
	}
	// 文字列をくくる記号('")があれば除去する
	for (i=0;i<args.length;i++) {
		if (args[i].search(/^[\'\"]/) != -1 && args[i].search(/[\'\"]$/) != -1) {
			args[i] = args[i].substr(1,args[i].length-2);
		}
	}
	// 優先順位３　&
	for (j=0;j<=1;j++) {
		f=1;
		for (i=0;i<args.length;i++) {
			if (args[i] == '&') {
				c = i;
				i = args.length;
				f=0;
				args[c-1] = String(args[c-1]) + String(args[c+1]) ;
				args.splice(c,2);
			}
		}
		j=f;
	}
	return args[0];
}

// 指定ラベルへ移動する・相対行移動する
// *スタート、文字列…指定ラベル
// +n、-n…n行進める、n行戻す
function progMoveLabel(str) {
	var i,n,r;
	r = -2;
	// 先頭の文字を見て処理分岐
	switch (str.charAt(0)) {
	case '+':
	case '-':
		// 数値に変換する
		n = parseInt(Number(str), 10);
		r = g_LineNumber + n - 1;
		break;
	default:
		if (str.charAt(0) != '*') str='*'+str;
		for (i=0;i<g_LabelName.length;i++) {
			if (g_LabelName[i] == str) {
				r = g_LabelLine[i];
				break;
			}
		}
	}
	// 移動先のラベルがなければUndefined labelエラーを返す
	if (r < -1) g_ErrorFlag = UNDEFINED_LABEL;
	return r;
}

// ------------------------- ここから命令群
// プログラムの終了（/end,/e）
function LLGEnd() {
	g_Status = PROG_END;
}

// 画面クリア（/cls, /c）
function LLGCls() {
	// var c = parseInt(g_ArgData[1]);
	// LCDCls(c);
	LCDCls(0);
}

// 表示位置設定（/locate, /l）
function LLGLocate() {
	var x = parseInt(progCalc(g_ArgData[1]));
	var y = parseInt(progCalc(g_ArgData[2]));
	LCDLocate(x ,y);
}

// 文字表示(/print, /p)
function LLGPrint() {
	LCDPrint(progConcat(g_ArgData[1]));
}

// 指定位置に文字表示（/pchr）
function LLGPrintChr() {
	var x = parseInt(progCalc(g_ArgData[1]));
	var y = parseInt(progCalc(g_ArgData[2]));
	LCDLocate(x ,y);
	LCDPrint(progConcat(g_ArgData[3]));
}

// キャラクターセット（/setchr）
function LLGSetChr(){
	setChrData(progConcat(g_ArgData[1]),progConcat(g_ArgData[2]));
}

// 変数代入(/let, /=)
function LLGLet() {
	var n;
	// 特別変数（@CNTのみ）なら専用の変数に入れる
	if (g_ArgData[1] == '@CNT') { g_Count = progCalc(g_ArgData[2]); return; }
	// 変数として該当するのがなければSyntax Errorを返す
	n = progVariableIndex(g_ArgData[1]);
	if ( n==-1 ) { g_ErrorFlag = SYNTAX_ERROR; return; }
	// 計算評価して変数に入れる
	g_Variable[n] = progConcat(g_ArgData[2]);
}

// 変数計算(/calc)
function LLGCalc() {
	var n;
	// 特別変数（@CNTのみ）なら専用の変数に入れる
	if (g_ArgData[1] == '@CNT') { g_Count = progCalc(g_ArgData[2]); return; }
	// 変数として該当するのがなければSyntax Errorを返す
	n = progVariableIndex(g_ArgData[1]);
	if ( n==-1 ) { g_ErrorFlag = SYNTAX_ERROR; return; }
	// 計算評価して変数に入れる
	g_Variable[n] = progCalc(g_ArgData[2]);
}

// 文字列連結（/concat）
function LLGConcat() {
	var n;
	// 特別変数（@CNTのみ）ならSyantax Errorを返す
	if (g_ArgData[1] == '@CNT') { g_ErrorFlag = SYNTAX_ERROR; return; }
	// 変数として該当するのがなければSyntax Errorを返す
	n = progVariableIndex(g_ArgData[1]);
	if ( n==-1 ) { g_ErrorFlag = SYNTAX_ERROR; return; }
	// 計算評価して変数に入れる
	g_Variable[n] = progConcat(g_ArgData[1]+'&'+g_ArgData[2]);
}

// ラベル移動(/goto)
function LLGGoto() {
	var r;
	r = progMoveLabel(g_ArgData[1]);
	if (r >= -1) g_LineNumber = r;
}

// サブルーチンへ移動(/gosub)
function LLGGosub() {
	var r;
	r = progMoveLabel(g_ArgData[1]);
	if (r >= 0) { g_GosubLine = g_LineNumber; g_LineNumber = r; }
}

// サブルーチンより帰還(/return,/ret)
function LLGReturn() {
	// /gosubを使わずに/returnを使った場合RETURN_WITHOUT_GOSUBエラーを返す
	if (g_GosubLine == -1) { g_ErrorFlag = RETURN_WITHOUT_GOSUB; return; }
	g_LineNumber = g_GosubLine;
	g_GosubLine = -1;
}

// リピート開始(/repeat)
function LLGRepeat() {
	var r;
	r = parseInt(progCalc(g_ArgData[1]));
	// リピートカウントが0未満なら実行せず終了
	if (r < 0) return ;
	g_MaxCount = r;
	g_Count = 0;
	g_RepeatLine = g_LineNumber;
}

// リピート終点(/loop)
function LLGLoop() {
	// /repeatを使わずに/loopを使った場合LOOP_WITHOUT_REPEATエラーを返す
	if (g_RepeatLine == -1) { g_ErrorFlag = LOOP_WITHOUT_REPEAT; return; }
	g_Count++;
	// カウントが最大値未満なら繰り返す
	if (g_Count < g_MaxCount) {
		g_LineNumber = g_RepeatLine;
	} else {
		// ループ終了
		g_RepeatLine = -1;
	}
}

// 条件分岐・数値比較（/if）
function LLGIf() {
	// /if,判定1,記号,判定2,成立ラベル,不成立ラベル
	var s1,ope,s2,movelbl,res;
	res = 1;
	s1 = Number(progCalc(g_ArgData[1]));
	ope = g_ArgData[2];
	s2 = Number(progCalc(g_ArgData[3]));
	// opeの記号で判断を決める
	switch (ope) {
	case '=':
	case '==':
		// 一致
		if (s1 == s2) res = 0;
		break;
	case '!=':
	case '<>':
		// 不一致
		if (s1 != s2) res = 0;
		break;
	case '>':
		// 大なり
		if (s1 > s2) res = 0;
		break;
	case '<':
		// 小なり
		if (s1 < s2) res = 0;
		break;
	case '>=':
	case '=>':
		// 以上
		if (s1 >= s2) res = 0;
		break;
	case '<=':
	case '=<':
		// 以下
		if (s1 <= s2) res = 0;
		break;
	default:
		// エラー
		g_ErrorFlag = SYNTAX_ERROR;
		return;
	}
	// 移動先ラベル決定
	movelbl = g_ArgData[res+4];
	// 移動先ラベルが'//'以外なら移動（'//'なら次の行へ）
	if (movelbl != '//') {
		r = progMoveLabel(movelbl);
		if (r >= 0) g_LineNumber = r;
	}
}

// 条件分岐・文字列比較（/strif,/sif）
function LLGStrIf() {
	// /strif,判定1,判定2,成立ラベル,不成立ラベル
	var s1,s2,movelbl,res;
	res = 1;
	s1 = progConcat(g_ArgData[1]);
	s2 = progConcat(g_ArgData[2]);
	if (s1 == s2) res = 0;
	// 移動先ラベル決定
	movelbl = g_ArgData[res+3];
	// 移動先ラベルが'//'以外なら移動（'//'なら次の行へ）
	if (movelbl != '//') {
		res = progMoveLabel(movelbl);
		if (res >= 0) g_LineNumber = res;
	}
}

// 乱数生成（/rnd）
function LLGRandom() {
	// /rnd,変数,最小値,最大値
	var n,a,b,r,t;
	// 変数として該当するのがなければSyntax Errorを返す
	n = progVariableIndex(g_ArgData[1]);
	if ( n==-1 ) { g_ErrorFlag = SYNTAX_ERROR; return; }
	// 最小値、最大値
	a = parseInt(g_ArgData[2]);
	b = parseInt(g_ArgData[3]);
	if (a > b) { t = a; a = b; b = t; }
	r = parseInt(Math.random()*(b-a+1)+a);
	// 計算評価して変数に入れる
	g_Variable[n] = progCalc(r);
}

// 文字列長さ(/len)
function LLGLen() {
	// len,変数,文字列
	var n,a,r;
	// 変数として該当するのがなければSyntax Errorを返す
	n = progVariableIndex(g_ArgData[1]);
	if ( n==-1 ) { g_ErrorFlag = SYNTAX_ERROR; return; }
	// 文字列の長さ
	a = progConcat(g_ArgData[2]);
	r = a.length;
	// 計算評価して変数に入れる
	g_Variable[n] = progCalc(r);
}

// 文字列抜出(/substr)
function LLGSubStr() {
	// substr,変数,文字列,開始位置,文字数
	var n,a,r,b,l,s;
	// 変数として該当するのがなければSyntax Errorを返す
	n = progVariableIndex(g_ArgData[1]);
	if ( n==-1 ) { g_ErrorFlag = SYNTAX_ERROR; return; }
	// 文字列の長さ
	a = progConcat(g_ArgData[2]);
	r = a.length;
	// 開始位置
	b = parseInt(progCalc(g_ArgData[3]));
	// 開始位置がマイナスならエラー
	if (b < 0) { g_ErrorFlag = SYNTAX_ERROR; return; }
	// 開始位置が文字列の長さ以上なら''を返す
	if (b >= r) { g_Variable[n] = ''; return; }
	// 文字数
	l = parseInt(progCalc(g_ArgData[4]));
	// 文字数が0以下ならエラー
	/* if (l <= 0) { g_ErrorFlag = SYNTAX_ERROR; return; } */
	s = a.substr(b, l);
	// 計算評価して変数に入れる
	g_Variable[n] = s;
}

// 文字列置き換え(/replace)
function LLGReplace() {
	// replace,変数,文字列,開始位置,置き換え文字
	var n,a,b,r,s1,s2;
	// 変数として該当するのがなければSyntax Errorを返す
	n = progVariableIndex(g_ArgData[1]);
	if ( n==-1 ) { g_ErrorFlag = SYNTAX_ERROR; return; }
	// 文字列
	a = progConcat(g_ArgData[2]);
	// 開始位置
	b = parseInt(progCalc(g_ArgData[3]));
	// 開始位置がマイナスならエラー
	if (b < 0) { g_ErrorFlag = SYNTAX_ERROR; return; }
	// 置き換え文字
	r = progConcat(g_ArgData[4]);
	// 文字数が0以下ならエラー
	if (r.length <= 0) { g_ErrorFlag = SYNTAX_ERROR; return; }
	// 開始位置前まで抜き出す
	s1 = a.substr(0, b);
	// 開始位置＋置き換え文字文字数以降で抜き出す
	s2 = a.substr(b+r.length);
	// 計算評価して変数に入れる
	g_Variable[n] = s1 + r + s2;
}

// 文字検索(/index)
function LLGInstr() {
	// instr,変数,文字列,検索文字列
	var n,a,b,r;
	// 変数として該当するのがなければSyntax Errorを返す
	n = progVariableIndex(g_ArgData[1]);
	if ( n==-1 ) { g_ErrorFlag = SYNTAX_ERROR; return; }
	// 文字列
	a = progConcat(g_ArgData[2]);
	// 検索文字列
	b = progConcat(g_ArgData[3]);
	// 検索結果
	g_Variable[n] = a.indexOf(b);
}

// 繰り返し文字列生成(/repstr)
function LLGRepeatString() {
	// repstr,変数,文字列,繰り返し数
	var n,s,l,r,i;
	// 変数として該当するのがなければSyntax Errorを返す
	n = progVariableIndex(g_ArgData[1]);
	if ( n==-1 ) { g_ErrorFlag = SYNTAX_ERROR; return; }
	// 文字列
	s = progConcat(g_ArgData[2]);
	// 繰り返し数
	l = progCalc(g_ArgData[3]);
	// 繰り返し
	r = '';
	for (i=0;i<l;i++) {
		r = r + s;
	}
	g_Variable[n] = r;
}

// 時間待ち
function LLGWait() {
	// wait,ミリ秒
	var n,dt0
	n = parseInt(progCalc(g_ArgData[1]));
	// 待ち時間0以下なら抜ける
	if (n <= 0) return;
	//
	dt0 = new Date();
	g_StartTime = dt0.getTime();
	g_WaitTime = n;
	g_Status = PROG_WAITING;
}

// ボタン情報
function LLGButton() {
	// button,変数
	var n;
	// 変数として該当するのがなければSyntax Errorを返す
	n = progVariableIndex(g_ArgData[1]);
	if ( n==-1 ) { g_ErrorFlag = SYNTAX_ERROR; return; }
	// 計算評価して変数に入れる
	g_Variable[n] = progCalc(g_button);
}

// ボタン受付
function LLGButtonResponse(n){
	g_clickable = n;
	g_button = -1;
}

// 押下されたボタンの位置で分岐
function LLGButtonGo() {
	// btngoto,移動先0,移動先1,移動先2,移動先3,移動先4,移動先5
	var n,movelbl,res;
	// ボタン情報を変数に入れる
	n = g_button;
	// 何処も押されてなければつぎの行へ
	if (n == -1) return;
	// 移動先ラベル決定
	movelbl = g_ArgData[n+1];
	// 移動先ラベルが'//'以外なら移動（'//'なら次の行へ）
	if (movelbl != '//') {
		res = progMoveLabel(movelbl);
		if (res >= 0) g_LineNumber = res;
	}
}

// ミリ秒取得
function LLGGetTime() {
	// getms,変数
	var n,d;
	// 変数として該当するのがなければSyntax Errorを返す
	n = progVariableIndex(g_ArgData[1]);
	if ( n==-1 ) { g_ErrorFlag = SYNTAX_ERROR; return; }
	// 計算評価して変数に入れる
	d = new Date();
	g_Variable[n] = progCalc(d.getTime());
}

// ビープ音を鳴らす
function LLGSound() {
	var n;
	n = progCalc(g_ArgData[1]);
	if ((n<0) || (n>=g_SE_FileList.length)) { g_ErrorFlag = SYNTAX_ERROR; return; }
	LCDSoundEffect(n);
}

// 絶対値を変数に入れる
function LLGAbsolute() {
	// abs,変数,計算データ
	var n;
	// 変数として該当するのがなければSyntax Errorを返す
	n = progVariableIndex(g_ArgData[1]);
	if ( n==-1 ) { g_ErrorFlag = SYNTAX_ERROR; return; }
	// 計算評価して変数に入れる
	g_Variable[n] = Math.abs(progCalc(g_ArgData[2]));
}

// 平方根の結果を変数に入れる
function LLGSquareRoot() {
	// sqrt,変数,計算データ
	var n;
	// 変数として該当するのがなければSyntax Errorを返す
	n = progVariableIndex(g_ArgData[1]);
	if ( n==-1 ) { g_ErrorFlag = SYNTAX_ERROR; return; }
	// 計算評価して変数に入れる
	g_Variable[n] = Math.sqrt(progCalc(g_ArgData[2]));
}

// 2つの変数の内容を入れ替える
function LLGSwap() {
	// swap 変数1,変数2
	var a,b,t;
	// 変数として該当するのがなければSyntax Errorを返す
	a = progVariableIndex(g_ArgData[1]);
	b = progVariableIndex(g_ArgData[2]);
	if ( a==-1 || b==-1 ) { g_ErrorFlag = SYNTAX_ERROR; return; }
	// 変数の内容交換
	t = g_Variable[a];
	g_Variable[a] = g_Variable[b];
	g_Variable[b] = t;
}
